import es.gva.cit.jecwcompress.*;
import es.gva.cit.jgdal.*;

public class EcwBandasLandsat{
	
	public static void Uso(){
		System.out.println("Uso 1: Comprime una ventana de la imagen.");
		System.out.println("	java TifToEcw file-src file-dst compresin num_bandas(3  5)");
	}
	
	public static void main(String[] args){
 
	  Gdal[] gdalimgs=null;
	  
	  int nbandas=0;
	  
	  NCSEcwCompressClient client;
	  ReadImgs lectura=null;
	  String[] images;
	  
	  if(args.length != 3){
	  	EcwBandasLandsat.Uso();
	  	return;
	  }
	  
	  nbandas = Integer.parseInt(args[2]);
	  if(nbandas!=3 && nbandas!=6){
	  	EcwBandasLandsat.Uso();
	  	return;
	  }
	  	

  	  images=new String[nbandas];
  	  gdalimgs =new Gdal[nbandas];
  	  for(int i=0;i<nbandas;i++)gdalimgs[i]=new Gdal();
	  
	  if(nbandas==6){
		  for(int i=0;i<nbandas-1;i++)
		  	images[i] = new String(args[0]+(i+1)+"0.tif");
	      images[5] = new String(args[0]+"70.tif");
	  }else if(nbandas==3){
		  images[0] = new String(args[0]+"30.tif");
		  images[1] = new String(args[0]+"20.tif");
		  images[2] = new String(args[0]+"10.tif");
	  }
	  
	  try{
		for(int i=0;i<nbandas;i++){
  			gdalimgs[i].open(images[i],Gdal.GA_ReadOnly);
  			System.out.println(images[i]);
  		}
	  }catch(Exception ge){
		ge.printStackTrace();
		//...........
	  }
	  
	  GdalRasterBand mirasterband=null;  
	  String st;
	  int nxsize=0;
	  int nysize=0;
	  int widthcompress = 0;
	  int heightcompress = 0;
	  int rastercount=nbandas;
	  String rasterband; 
	  GeoTransform gt=null;	  
	  	  
	  try{
	    nxsize = gdalimgs[0].getRasterXSize();
	    nysize = gdalimgs[0].getRasterYSize();
	    System.out.println("N BANDAS="+rastercount+" SIZEX="+nxsize+" SIZEY="+nysize);	
	  }catch(GdalException ge){
	  						ge.printStackTrace();
	  						//...........
	  					   }
	
	  widthcompress = nxsize;
	  heightcompress = nysize;
	  
	  try{
	  	gt = gdalimgs[0].getGeoTransform();
	  	System.out.println("Origins = ("+gt.adfgeotransform[0]+","+gt.adfgeotransform[3]+")");
	  	System.out.println("Pixel Size = ("+gt.adfgeotransform[1]+","+gt.adfgeotransform[5]+")");
	  }catch(GdalException e){
	  		System.out.println("No puedo obtener el array geoTransform.");
			e.printStackTrace();
			//...........
	  }
	  
	  try{
	  	client = new NCSEcwCompressClient();
	  	
	  	if(nbandas==6)client.setOutputFilename(args[0]+"123457multibanda.ecw");
	  	else if(nbandas==3)client.setOutputFilename(args[0]+"321multibanda.ecw");
	  	client.setInputFilename("");
	    client.setTargetCompress(Double.parseDouble(args[1]));
	    client.setInOutSizeX(widthcompress);
	    client.setInOutSizeY(heightcompress);
	    client.setInputBands(rastercount);
	    

	    client.setCompressFormat(CompressFormat.COMPRESS_MULTI);
		
		
		client.setCellIncrementX(gt.adfgeotransform[1]);
		client.setCellIncrementY(gt.adfgeotransform[5]);
		client.setOriginX(gt.adfgeotransform[0]);
		client.setOriginY(gt.adfgeotransform[3]);
		client.setCellSizeUnits(1);
		
			
		lectura = new ReadImgs(gdalimgs, client, widthcompress, heightcompress, nbandas);
		client.NCSEcwCompressOpen(false);
		client.NCSEcwCompress(lectura);
		client.NCSEcwCompressClose();
	  			
	  }catch(EcwException e){
		e.printStackTrace();
		//...........
	  }
	  
	   		  
	  try{	  	    	    
	  	 for(int i=0;i<nbandas;i++)gdalimgs[i].close();
	  }catch(GdalException e){
	  							e.printStackTrace();
	  						 }
	  
	  
	}  
}

/**
 *
 * Para la lectura hay que hacer una clase que extienda de JniObject e implemente ReadCallBack
 * . Esto obliga a crear un mtodo loadBuffer. En el hay que meter la funcionalidad para que
 * llene el buffer. El buffer esta en la clase cliente y tendr una longitud de 
 * ancho de una lnea * nmero de bandas
 */

class ReadImgs extends JniObject implements ReadCallBack {
	
	private GdalBuffer[] buffers;
	private GdalRasterBand mirasterband=null;
	private Gdal[] gdalimgs=null;
	private NCSEcwCompressClient client=null;
	private int width, height;
		
	public ReadImgs(Gdal[] g, NCSEcwCompressClient client, int width, int height, int nbandas){
		gdalimgs = g;
		this.client = client;
		this.width = width;
		this.height = height;
		buffers = new GdalBuffer[nbandas];
		
	}
	
	public void loadBuffer(){
	
		try{
			for(int iBand=0;iBand<gdalimgs.length;iBand++){
				mirasterband=gdalimgs[iBand].getRasterBand(1);
		  		buffers[iBand] = mirasterband.readRaster(0, nNextLine, width, 1, width, 1, 1);
		  		for(int pos=0; pos<width; pos++){
		  			client.buffer[pos+(width*iBand)]=buffers[iBand].buffByte[pos];
		  		}
			}
	  	}catch(GdalException e){ 
	  		System.out.println("Error en la lectura de lineas con Gdal.");
	  		System.exit(1);
	  	}
	  	
	  	 
	  			
	}
	
	public void updatePercent(){
		System.out.println(client.getPercent()+"%");
	}
}